﻿Public Class Filters

    Private sw As Stopwatch = New Stopwatch
    Private isHighPass As Boolean
    Private tauMS As Double          ' filter time constant in milliseconds
    Private lastMS As Double         ' last time in milliseconds
    Private outValue As Double

    Friend Sub New(ByVal freq As Double, ByVal hiPass As Boolean)
        sw.Start()
        outValue = 0
        lastMS = sw.Elapsed.TotalMilliseconds
        isHighPass = hiPass
        SetFrequency(freq)
    End Sub

    Friend Sub SetFrequency(ByVal freq As Double)
        tauMS = 1000 / (Math.PI * 2 * freq)
    End Sub

    Friend Sub ResetTo(ByVal inValue As Double)
        outValue = inValue
    End Sub

    Friend Function Filter(ByVal inValue As Double) As Double
        '
        Dim time As Double = sw.Elapsed.TotalMilliseconds
        Dim elapsedMS As Double = time - lastMS
        lastMS = time
        '
        Dim tauSamps As Double = tauMS / elapsedMS
        Dim ampFactor As Double = Math.Exp(-1 / tauSamps)
        '
        outValue = (1 - ampFactor) * inValue + ampFactor * outValue
        '
        If isHighPass Then
            Return inValue - outValue
        Else
            Return outValue
        End If
    End Function

End Class
