﻿Imports System.Drawing.Drawing2D

Public Class GraphPaper

    Private xScale As Int32

    Private hpix As Int32
    Private wpix As Int32

    Private BackColor As Color = Color.FromArgb(240, 230, 200)
    Private scalePen1 As Pen = New Pen(Color.FromArgb(150, 120, 120))
    Private scalePen2 As Pen = New Pen(Color.FromArgb(200, 200, 200))
    Private scalePen3 As Pen = New Pen(Color.FromArgb(250, 250, 140), 7)
    Private audioBorderPen As Pen = New Pen(Color.FromArgb(50, 40, 40), 1)
    Private markerBrush1 As Brush = New SolidBrush(Color.FromArgb(0, 0, 255))
    Private markerBrush2 As Brush = New SolidBrush(Color.FromArgb(0, 255, 0))
    Private markerBrush3 As Brush = New SolidBrush(Color.FromArgb(240, 120, 0))
    Private markerBrush4 As Brush = New SolidBrush(Color.FromArgb(255, 0, 0))
    Private GradientBrush As Drawing2D.LinearGradientBrush
    Private markerSetPenLow As Pen = New Pen(Color.FromArgb(50, 80, 170), 3)
    Private markerSetPenHi As Pen = New Pen(Color.FromArgb(170, 80, 50), 3)
    Private markerSetPenManual As Pen = New Pen(Color.FromArgb(0, 150, 0), 2)
    Private tracePen1 As Pen = New Pen(Color.FromArgb(50, 0, 0), 1)
    Private tracePen2 As Pen = New Pen(Color.FromArgb(0, 90, 0), 2)
    Private textBrush As Brush
    Private hilightBack As Brush = New SolidBrush(Color.FromArgb(90, 255, 255, 100))
    Private hilightText As Brush = New SolidBrush(Color.FromArgb(50, 50, 50))
    Private textFont As Font = New Font("Arial", 11, FontStyle.Bold)

    ' ==============================================================================
    '  UpdateDeltaTime by DeltaPixels
    ' ==============================================================================
    Friend Sub UpdateDeltaTimeBy(ByVal DeltaPixels As Int32)
        DeltaTime += DeltaPixels * 100 * xScale
        LimitDeltaTime()
    End Sub

    Friend Sub UpdateXscale(ByVal _xScale As Int32)
        xScale = _xScale
    End Sub

    Friend Function GetTimeMillisec() As Int32
        Return CInt(DataArray1.GetNumEntries * 100 - DeltaTime)
    End Function

    Friend Sub SetTimeMillisec(ByVal millisec As Int32)
        DeltaTime = CInt(DataArray1.GetNumEntries * 100 - millisec)
    End Sub


    Friend Sub Update(ByVal pbox As PictureBox)
        '
        'Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()
        ' --------------------------------------------------------------------- 
        If Not pbox.Visible Then Return
        InitPictureboxImage(pbox)
        ' --------------------------------------------------------------------- 
        Dim v1, v2 As Single
        Dim i As Int32
        Dim x As Single
        Dim y1, y2, y3 As Single
        Dim oldx As Int32
        Dim oldy1, oldy2 As Single
        Dim s As String
        Dim sz As SizeF
        hpix = pbox.Image.Height - 1
        wpix = pbox.Image.Width - 5
        Dim ArrayReadIndex As Int32
        If hpix < 1 Or wpix < 1 Then Return
        ' ---------------------------------------------------------------------
        Dim g As Graphics = Graphics.FromImage(pbox.Image)
        g.Clear(BackColor)
        ' --------------------------------------------------------------------- array index with deltatime
        ArrayReadIndex = CInt(DataArray1.GetWriteIndex - wpix * xScale)
        ArrayReadIndex -= CInt(DeltaTime / 2 / 50)
        ' --------------------------------------------------------------------- stabilize and suppress aliasing effect
        ArrayReadIndex = (CInt(xScale * CInt(ArrayReadIndex / xScale)))
        ' ---------------------------------------------------------------------
        Dim movingposition As Single
        movingposition = (CSng(ArrayReadIndex) / xScale) Mod 25

        ' ----------------------------------------------------------------- hilight yellow area
        y3 = hpix * 0.625F
        g.DrawLine(scalePen3, 0, y3, wpix, y3)
        ' ----------------------------------------------------------------- draw scale x
        For i = -25 To wpix + 25
            x = i - movingposition
            If i Mod 25 = 0 Then
                g.DrawLine(scalePen1, x, 0, x, hpix)
            ElseIf i Mod 5 = 0 Then
                g.DrawLine(scalePen2, x, 0, x, hpix)
            End If
        Next
        ' ----------------------------------------------------------------- draw scale y
        For i = 0 To 65
            y1 = hpix * i / 65.0F
            If i Mod 10 = 0 Then
                g.DrawLine(scalePen1, 0, y1, wpix + 1, y1)
            ElseIf i Mod 5 = 0 Then
                g.DrawLine(scalePen2, 0, y1, wpix + 1, y1)
            End If
        Next

        ' --------------------------------------------------------------------- draw all waves
        g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        oldx = -1
        oldy1 = 0
        oldy2 = 0
        For ix As Int32 = 0 To wpix
            For j As Int32 = 1 To xScale
                ArrayReadIndex += 1
                If ArrayReadIndex < 0 Then Continue For
                Select Case DataArray1.GetElement(CInt(ArrayReadIndex)).Marker
                    Case 1 : g.FillRectangle(markerBrush1, ix - 1, 0, 3, hpix)
                    Case 2 : g.FillRectangle(markerBrush2, ix - 1, 0, 3, hpix)
                    Case 3 : g.FillRectangle(markerBrush3, ix - 1, 0, 3, hpix)
                    Case 4 : g.FillRectangle(markerBrush4, ix - 1, 0, 3, hpix)
                    Case 10 : g.DrawLine(markerSetPenLow, ix - 1, y3 - 6, ix - 1, y3 + 6)
                    Case 11 : g.DrawLine(markerSetPenHi, ix - 1, y3 - 6, ix - 1, y3 + 6)
                    Case 12 : g.DrawEllipse(markerSetPenManual, ix - 3, y3 - 3, 7, 7)
                End Select
            Next
            If ArrayReadIndex < 0 Then Continue For
            v1 = DataArray1.GetElement(CInt(ArrayReadIndex)).SignalValue
            v2 = DataArray1.GetElement(CInt(ArrayReadIndex)).TaValue
            If v1 = -999 Or v2 = 999 Then Continue For
            If PlayingAudio Then
                OutputValue = v1
                TaValue = v2
            End If
            ' ----------------------------------------------------------------- calc SIGNAL
            v1 = (v1 - MinSignalScale) / (MaxSignalScale - MinSignalScale)
            v1 = v1 * hpix
            y1 = hpix - v1
            ' ----------------------------------------------------------------- calc TA
            v2 = (v2 - MinTaScale) / (MaxTaScale - MinTaScale)
            v2 = v2 * hpix
            y2 = hpix - v2
            ' ----------------------------------------------------------------- draw SIGNAL and TA 
            If oldx >= 0 Then
                g.DrawLine(tracePen1, oldx, oldy1, ix, y1)
                g.DrawLine(tracePen2, oldx, oldy2, ix, y2)
            End If
            ' ----------------------------------------------------------------- set old values
            oldx = ix
            oldy1 = y1
            oldy2 = y2
        Next
        ' --------------------------------------------------------------------- draw text
        s = MillisecToHourMinAndSec(GetTimeMillisec)
        s = "Session time: " + s
        sz = g.MeasureString(s, textFont)
        g.FillRectangle(hilightBack, (wpix - sz.Width) / 2.0F - 3, 3, sz.Width - 2, sz.Height - 2)
        g.DrawString(s, textFont, hilightText, (wpix - sz.Width) / 2.0F, 2)
        ' --------------------------------------------------------------------- TA Counter
        'Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()
        Dim c As Single = DataArray1.CalcTaCounterFromStart(CInt(GetTimeMillisec() / 100) - 1)
        'Form1.Text = "TA counter time: " & (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0") & " uS"
        If wpix > 450 Then
            s = "TA counter: " + c.ToString("0.00", GCI)
        Else
            s = "TActr: " + c.ToString("0.00", GCI)
        End If
        sz = g.MeasureString(s, textFont)
        g.FillRectangle(hilightBack, wpix - sz.Width - 3, 3, sz.Width - 2, sz.Height - 2)
        g.DrawString(s, textFont, hilightText, wpix - sz.Width, 2)
        ' --------------------------------------------------------------------- show
        pbox.Invalidate()
        'ReportString = "Scope time: " & (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0") & " uS"
        'Form1.Text = "Scope time: " & (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0") & " uS"
    End Sub


    Friend Sub UpdateAudio(ByVal pbox As PictureBox)
        '
        'Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()
        ' --------------------------------------------------------------------- 
        If Not pbox.Visible Then Return
        InitPictureboxImage(pbox)
        If pbox.Image Is Nothing Then Return
        If GradientBrush Is Nothing Then GradientBrush = CreateFillBrush(pbox)
        ' --------------------------------------------------------------------- 
        Dim p As Pen = New Pen(Color.FromArgb(0, 0, 0))
        Dim v1 As Byte
        Dim i As Int32
        Dim x As Single
        Dim y As Single
        Dim oldx, oldy As Single
        hpix = pbox.Image.Height - 1
        wpix = pbox.Image.Width - 5
        Dim ArrayReadIndex As Int32
        If hpix < 1 Or wpix < 1 Then Return
        ' ---------------------------------------------------------------------
        Dim g As Graphics = Graphics.FromImage(pbox.Image)
        g.Clear(BackColor)
        ' --------------------------------------------------------------------- array index with deltatime
        ArrayReadIndex = CInt(DataArray1.GetWriteIndex - wpix * xScale)
        ArrayReadIndex -= CInt(DeltaTime / 2 / 50)
        ' --------------------------------------------------------------------- stabilize and suppress aliasing effect
        ArrayReadIndex = (CInt(xScale * CInt(ArrayReadIndex / xScale)))
        ' ---------------------------------------------------------------------
        Dim movingposition As Single
        movingposition = (CSng(ArrayReadIndex) / xScale) Mod 25

        ' ----------------------------------------------------------------- draw scale x
        For i = -25 To wpix + 25
            x = i - movingposition
            If i Mod 25 = 0 Then
                g.DrawLine(scalePen1, x, 0, x, hpix)
            ElseIf i Mod 5 = 0 Then
                g.DrawLine(scalePen2, x, 0, x, hpix)
            End If
        Next
        ' ----------------------------------------------------------------- draw scale y
        For i = 0 To 4
            y = hpix * i / 4.0F
            g.DrawLine(scalePen2, 0, y, wpix, y)
        Next

        ' --------------------------------------------------------------------- draw all waves
        g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
        For ix As Int32 = 0 To wpix
            Dim max As Byte = 0
            For j As Int32 = 1 To xScale
                ArrayReadIndex += 1
                If ArrayReadIndex < 0 Then Continue For
                Select Case DataArray1.GetElement(CInt(ArrayReadIndex)).Marker
                    Case 1 : g.FillRectangle(markerBrush1, ix - 1, 0, 3, hpix)
                    Case 2 : g.FillRectangle(markerBrush2, ix - 1, 0, 3, hpix)
                    Case 3 : g.FillRectangle(markerBrush3, ix - 1, 0, 3, hpix)
                    Case 4 : g.FillRectangle(markerBrush4, ix - 1, 0, 3, hpix)
                End Select
                v1 = DataArray1.GetElement(CInt(ArrayReadIndex)).AudioLevel
                If v1 > max Then max = v1
            Next
            ' ----------------------------------------------------------------- calc y position
            y = hpix - max * hpix / 256.0F
            ' ----------------------------------------------------------------- draw SIGNAL and TA 
            g.FillRectangle(GradientBrush, ix, y, 1, hpix - y)
            g.DrawLine(audioBorderPen, oldx, oldy, ix, y)
            ' ----------------------------------------------------------------- set old values
            oldx = ix
            oldy = y
        Next
        ' --------------------------------------------------------------------- show
        pbox.Invalidate()
        'ReportString = "Scope time: " & (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0") & " uS"
        'Form1.Text = "Scope time: " & (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0") & " uS"
    End Sub

    Private Function CreateFillBrush(ByVal pbox As PictureBox) As LinearGradientBrush
        CreateFillBrush = New LinearGradientBrush(pbox.ClientRectangle, _
                                                  Color.Black, _
                                                  Color.Black, _
                                                  LinearGradientMode.Vertical)
        Dim myBlend As ColorBlend = New ColorBlend()
        myBlend.Colors = New Color() {Color.FromArgb(255, 0, 0), _
                                      Color.FromArgb(255, 180, 0), _
                                      Color.FromArgb(120, 200, 0), _
                                      Color.FromArgb(0, 100, 0)}
        myBlend.Positions = New Single() {0.0F, 0.5F, 0.8F, 1.0F}
        CreateFillBrush.InterpolationColors = myBlend
    End Function

End Class
