﻿
Public Class Form1

    Private Slot_Input As Int32
    Private Slot_Output As Int32
    Private Slot_Set As Int32
    Private Slot_SetTime As Int32
    Private Slot_Gain As Int32
    Private Slot_Speed As Int32
    Private InputValue As Single
    Private ResValue As Single
    Private Gain As Int32
    Private TaZero As Single

    Friend ControlsType As Int32

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '
        'CloseAppByFilename("Theremino_HAL")
        StartThereminoHAL_Async()
        '
        ToolStrip1.Renderer = New ToolStripButtonRenderer
        ' -------------------------------------------
        Load_INI()
        EnableAudioControls()
        FillAudioDevicesCombo()
        cmb_BitsPerSec.Text = "128 kbps"
        Set_Props()
        ShowControls()
        ' -------------------------------------------
        DataArray1.Fill(999, -999, 0, 0)
        SetStatusStripControls(StatusStrip1)
        LoadDataFrom(LastDataFile)
        UpdateStatusTime()
        ' -------------------------------------------
        Slots.WriteSlot(Slot_Input, 1000)
        ' -------------------------------------------
        Me.Text = AppTitleAndVersion()
        ' -------------------------------------------
        GraphPaper1.Update(pbox_Paper)
        GraphPaper1.UpdateAudio(pbox_AudioLevel)
        Refresh()
        Opacity = 1
        ' -------------------------------------------
        Timer1.Interval = 16
        Timer1.Start()
        Timer2.Interval = 100
        Timer2.Start()
        'Timer_InitialAutoSet.Interval = 100
        'Timer_InitialAutoSet.Start()
        ' -------------------------------------------
        EventsAreEnabled = True
    End Sub

    Private Sub Form_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        If UnsavedData Then AskForSaveData()
        Save_INI()
        Me.Refresh()
        e.Cancel = False
        Timer1.Stop()
        StopThereminoHAL()
        Audio1.Close()
        DeleteTempFiles()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    ' auto set every 100 mS for 5 seconds
    Private Sub Timer_InitialAutoSet_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_InitialAutoSet.Tick
        Static counter As Int32 = 0
        counter += 1
        If counter > 50 Then Timer_InitialAutoSet.Stop()
        TaValue = 6.49
        SetZero()
    End Sub


    ' ===================================================================================
    '   ToolStrip Gradient
    ' ===================================================================================
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub

    ' ===================================================================================
    '  ToolStrip PressedButton color
    ' ===================================================================================
    Class ToolStripButtonRenderer
        Inherits System.Windows.Forms.ToolStripProfessionalRenderer
        Protected Overrides Sub OnRenderButtonBackground(ByVal e As ToolStripItemRenderEventArgs)
            Dim btn As ToolStripButton = CType(e.Item, ToolStripButton)
            If btn IsNot Nothing AndAlso btn.CheckOnClick AndAlso btn.Checked Then
                Dim bounds As Rectangle = New Rectangle(0, 0, e.Item.Width - 1, e.Item.Height - 1)
                Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                               Color.Gold, _
                                                               Color.FromArgb(250, 250, 250), _
                                                               Drawing2D.LinearGradientMode.Vertical)
                e.Graphics.FillRectangle(brush, bounds)
                e.Graphics.DrawRectangle(Pens.Orange, bounds)
            Else
                MyBase.OnRenderButtonBackground(e)
            End If
        End Sub
    End Class

    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    ' =======================================================================================
    '  TOOLBAR
    ' =======================================================================================
    Private Sub ToolStripButton_ShowControls_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_ShowControls.Click
        ControlsType = (ControlsType + 1) Mod 4
        ShowControls()
        GraphPaper1.Update(pbox_Paper)
        GraphPaper1.UpdateAudio(pbox_AudioLevel)
        Save_INI()
    End Sub
    Private Sub ShowControls()
        Select Case ControlsType
            Case 0
                Width = 460
                GroupBox_Input.Visible = False
                GroupBox_InOutSlots.Visible = False
                GroupBox_Controls.Visible = False
                GroupBox_AudioOptions.Visible = False
                GroupBox_Compression.Visible = False
                ToolStripButton_ShowControls.Text = "Show inputs"
                ToolStripButton_EditNotes.Text = "Edit"
                ToolStripButton_About.Visible = False
            Case 1
                Width = 615
                GroupBox_Input.Visible = True
                GroupBox_InOutSlots.Visible = True
                GroupBox_Controls.Visible = False
                GroupBox_AudioOptions.Visible = False
                GroupBox_Compression.Visible = False
                ToolStripButton_ShowControls.Text = "Show audio options"
                ToolStripButton_EditNotes.Text = "Edit annotations"
                ToolStripButton_About.Visible = True
            Case 2
                Width = 615
                GroupBox_AudioOptions.Location = GroupBox_Input.Location
                GroupBox_Compression.Location = GroupBox_Input.Location
                GroupBox_Compression.Top = GroupBox_AudioOptions.Bottom + 8
                GroupBox_Input.Visible = False
                GroupBox_InOutSlots.Visible = False
                GroupBox_AudioOptions.Visible = True
                GroupBox_Compression.Visible = True
                GroupBox_Controls.Visible = False
                ToolStripButton_ShowControls.Text = "Show markers"
                ToolStripButton_EditNotes.Text = "Edit annotations"
                ToolStripButton_About.Visible = True
            Case 3
                Width = 615
                GroupBox_Controls.Location = GroupBox_Input.Location
                GroupBox_Input.Visible = False
                GroupBox_InOutSlots.Visible = False
                GroupBox_AudioOptions.Visible = False
                GroupBox_Compression.Visible = False
                GroupBox_Controls.Visible = True
                ToolStripButton_ShowControls.Text = "Hide all controls"
                ToolStripButton_EditNotes.Text = "Edit annotations"
                ToolStripButton_About.Visible = True
        End Select
    End Sub

    Private Sub btn_LoadData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_LoadData.Click
        StopSession()
        PlayAudioStop()
        LoadData()
        FlushMouseEvents(Me)
        DeltaTime = 0
        UpdateGraphPaper = True
    End Sub
    Private Sub FlushMouseEvents(ByVal frm As Form)
        frm.Enabled = False
        Application.DoEvents()
        frm.Enabled = True
    End Sub
    Private Sub btn_SaveData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SaveData.Click
        StopSession
        PlayAudioStop()
        SaveData()
    End Sub
    Private Sub ToolStripButton_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_SaveImage.Click
        ToolStripButton_SaveImage.Visible = False
        ToolStripButton_SaveImage.Visible = True
        Me.Refresh()
        SaveImage("ThereminoEmotionMeter_", Me)
    End Sub
    Private Sub ToolStripButton_EditNotes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_EditNotes.Click
        Dim NotesFile As String
        If LastDataFile = "" Or LastDataFile.ToLower.Contains("not saved") Then
            NotesFile = Application.StartupPath + "\DataFiles\Temp.rtf"
        Else
            NotesFile = IO.Path.ChangeExtension(LastDataFile, ".rtf")
        End If
        If Not IO.File.Exists(NotesFile) Then IO.File.Create(NotesFile)
        Process.Start(NotesFile)
    End Sub
    Private Sub ToolStripButton_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_About.Click
        Form_About.ShowDialog()
    End Sub

   
    ' ================================================================================================
    '  SAVE INI ON LOST-FOCUS
    ' ================================================================================================
    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles _
                                                                    txt_SlotIn.LostFocus, _
                                                                    txt_SlotOut.LostFocus, _
                                                                    txt_SlotSet.LostFocus, _
                                                                    txt_SlotSetTime.LostFocus, _
                                                                    txt_SlotGain.LostFocus, _
                                                                    txt_SlotSpeed.LostFocus, _
                                                                    chk_Fast.LostFocus, _
                                                                    tkbar_SetTime.LostFocus, _
                                                                    tkbar_Gain.LostFocus, _
                                                                    tkbar_Speed.LostFocus, _
                                                                    chk_RecordAudio.LostFocus, _
                                                                    cmb_AudioInDevices.LostFocus, _
                                                                    cmb_BitsPerSec.LostFocus
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub


    ' ================================================================================================
    '  SET PROPERTIES
    ' ================================================================================================
    Private Sub Properties_TextChanged(ByVal sender As Object, _
                                       ByVal e As System.EventArgs) Handles _
                                                                    txt_SlotIn.TextChanged, _
                                                                    txt_SlotOut.TextChanged, _
                                                                    txt_SlotSet.TextChanged, _
                                                                    txt_SlotSetTime.TextChanged, _
                                                                    txt_SlotGain.TextChanged, _
                                                                    txt_SlotSpeed.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub

    Private Sub Set_Props()
        If tkbar_SetTime.Value = 0 Then
            tkbar_SetTime.Text = "Manual SET"
        ElseIf tkbar_SetTime.Value = 1 Then
            tkbar_SetTime.Text = "Raw autoset"
        Else
            tkbar_SetTime.Text = "Set time (sec)"
        End If
        AnalogMeter1.RingingType = If(chk_Fast.Checked, 1, 0)
        Gain = tkbar_Gain.Value
        GraphPaper1.UpdateXscale(51 - tkbar_Speed.Value)
        Slot_Input = txt_SlotIn.NumericValueInteger
        Slot_Output = txt_SlotOut.NumericValueInteger
        Slot_Set = txt_SlotSet.NumericValueInteger
        Slot_SetTime = txt_SlotSetTime.NumericValueInteger
        Slot_Gain = txt_SlotGain.NumericValueInteger
        Slot_Speed = txt_SlotSpeed.NumericValueInteger
    End Sub

    Private Sub chk_Fast_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_Fast.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub
    Private Sub tkbar_SetTime_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_SetTime.ValueChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub
    Private Sub tkbar_Gain_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Gain.ValueChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub
    Private Sub tkbar_Speed_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Speed.ValueChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
        UpdateGraphPaper = True
    End Sub

    ' ====================================================================================================
    '  Set DeltaTime by MouseDown and MouseMove on the BPM graph
    ' ====================================================================================================
    Private oldx As Int32
    Private EditDeltaTime As Boolean

    Private Sub pbox_Paper_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_Paper.MouseDown, _
                                                                                        pbox_AudioLevel.MouseDown
        If RecordingSession Then Return
        If e.Button = MouseButtons.Left Then
            oldx = e.X
            EditDeltaTime = True
        End If
    End Sub
    Private Sub pbox_Paper_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_Paper.MouseMove, _
                                                                                        pbox_AudioLevel.MouseMove
        If e.Button = MouseButtons.Left Then
            If EditDeltaTime Then
                Dim delta As Int32 = e.X - oldx
                If My.Computer.Keyboard.ShiftKeyDown Then delta *= 100
                If My.Computer.Keyboard.CtrlKeyDown Then delta *= 10
                GraphPaper1.UpdateDeltaTimeBy(delta)
                TrackAudioPosition_RepetitionLimited()
                oldx = e.X
                UpdateStatusTime()
                UpdateGraphPaper = True
            End If
        End If
    End Sub
    Private Sub pbox_Paper_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_Paper.MouseUp, _
                                                                                        pbox_AudioLevel.MouseUp
        EditDeltaTime = False
        TrackAudioPosition_Immediate()
    End Sub

    ' ====================================================================================================
    '  Mouse Wheel for ECG and BPM Graphs with variable scroll speed
    ' ====================================================================================================
    Private Sub pbox_GraphBpm_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_Paper.MouseWheel, _
                                                                                        pbox_AudioLevel.MouseWheel
        If RecordingSession Then Return
        Dim delta As Single = -e.Delta
        If My.Computer.Keyboard.ShiftKeyDown Then delta *= 100
        If My.Computer.Keyboard.CtrlKeyDown Then delta *= 10
        GraphPaper1.UpdateDeltaTimeBy(CInt(delta * 0.1 * VariableScrollSpeed()))
        UpdateStatusTime()
        TrackAudioPosition_RepetitionLimited()
        UpdateGraphPaper = True
    End Sub
    Private Function VariableScrollSpeed() As Single
        Static ks As Double
        Static oldtime As DateTime
        Dim k As Double = 0.05 / DateTime.Now.Subtract(oldtime).TotalSeconds
        oldtime = DateTime.Now
        k = k ^ 2
        k = Math.Max(k, 1)
        k = Math.Min(k, 50)
        ks += 0.3 * (k - ks)
        'Debug.Print(k.ToString("0.0"))
        Return CSng(ks)
    End Function

    ' ================================================================================================
    '  Manual SET by clicking on the AnalogMeter
    ' ================================================================================================
    Private Sub AnalogMeter1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AnalogMeter1.Click
        SetZero()
    End Sub

    Private Sub SetZero()
        If tkbar_SetTime.Value > 1 Then
            hipass1.ResetTo(-TaValue)
        Else
            TaZero = TaValue
        End If
        AnalogMeter1.RingingCounter = 9
        NewMarker = 12 ' 12 = marker for "MANUAL SET"
    End Sub

    ' ================================================================================================
    '  TIMED EXECUTION - FAST TIMER ( 60 Hz )
    ' ================================================================================================
    Private hipass1 As Filters = New Filters(0.1, True)

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return

        Dim TA As Single = 0
        ' ------------------------------------------------------------------ Slot Input
        If Slot_Input >= 0 Then
            ' -------------------------------------------------------------- 
            InputValue = Slots.ReadSlot_NoNan(Slot_Input)
            ' -------------------------------------------------------------- input to RES
            Dim i As Single = InputValue
            If i > 998 Then i = 998
            If i < 0 Then i = 0
            ResValue = 22000 * i / (1000 - i)
            ' -------------------------------------------------------------- RES to TA
            TA = ResValue / (ResValue + 21250.0F) * 5.559F + 0.941F
            ' -------------------------------------------------------------- show InputValue, RES an TA
            txt_InputValue.Text = InputValue.ToString("0", GCI)
            If ResValue >= 10000000 Then
                txt_Res.Text = "INF"
            ElseIf ResValue >= 1000000 Then
                txt_Res.Text = (ResValue / 1000000).ToString("0.0", GCI) + " M"
            ElseIf ResValue >= 50000 Then
                txt_Res.Text = (ResValue / 1000).ToString("0", GCI) + " K"
            ElseIf ResValue >= 10000 Then
                txt_Res.Text = RoundTo05(ResValue / 1000).ToString("0.0", GCI) + " K"
            Else
                txt_Res.Text = ResValue.ToString("0")
            End If
            txt_Ta.Text = TA.ToString("0.00", GCI)
        End If

        ' ------------------------------------------------------------------ prepare TaValue and OutputValue
        If Not PlayingAudio Then
            TaValue = TA

            If tkbar_SetTime.Value = 0 Then
                ' ---------------------------------------------------------- manual SET
                OutputValue = CSng(TaZero - TaValue) * Gain * 20.0F
            ElseIf tkbar_SetTime.Value = 1 Then
                ' ---------------------------------------------------------- raw auto SET
                OutputValue = CSng(TaZero - TaValue) * Gain * 20.0F
                If OutputValue < -45 Or OutputValue > 75 Then
                    If OutputValue < -45 Then OutputValue = -45
                    If OutputValue > 75 Then OutputValue = 75
                    PlayClickSound()
                    For i As Int32 = 1 To 4
                        AnalogMeter1.RingingCounter = 9
                        AnalogMeter1.TaValue = TaValue
                        AnalogMeter1.Value = OutputValue
                        AnalogMeter1.Refresh()
                    Next
                    TaZero = TaValue : OutputValue = 0
                    AnalogMeter1.RingingCounter = 9
                    AnalogMeter1.Refresh()
                    NewMarker = 10 ' 10 = marker for "SET"
                End If
            Else
                ' ---------------------------------------------------------- zero and gain
                Dim v As Double
                v = -TaValue
                v = hipass1.Filter(v)
                OutputValue = CSng(v) * Gain * 20.0F
                ' ---------------------------------------------------------- autorange
                Dim autorange As Double
                If OutputValue > 0 Then autorange = OutputValue / 75
                If OutputValue < 0 Then autorange = OutputValue / -45
                autorange *= 1.5
                If autorange < 1 Then autorange = 1
                hipass1.SetFrequency(autorange ^ 4 * 1 / tkbar_SetTime.Value)
            End If

            ' -------------------------------------------------------------- set limits
            If OutputValue > 75 Then OutputValue = 75
            If OutputValue < -45 Then OutputValue = -45
        End If

        ' ---------------------------------------------------------------------- set analog meter values
        AnalogMeter1.TaValue = TaValue
        AnalogMeter1.Value = OutputValue
        AnalogMeter1.TimeString = MillisecToHMS(DataArray1.GetNumEntries * 100)
        ' ---------------------------------------------------------------------- refresh meter
        AnalogMeter1.Refresh()

        ' ---------------------------------------------------------------------- Slot Output
        If Slot_Output >= 0 Then
            Slots.WriteSlot(Slot_Output, (OutputValue + 45.0F) / 120.0F * 1000)
        End If
        ' ---------------------------------------------------------------------- Slot Set
        If Slot_Set >= 0 Then
            If Slots.ReadSlot_NoNan(Slot_Set) > 500 Then
                SetZero()
            End If
        End If
        ' ---------------------------------------------------------------------- Slot SetTime
        If Slot_SetTime >= 0 Then
            Static OldSetTime As Int32 = -1
            Dim NewValue As Single = CInt(Slots.ReadSlot_NoNan(Slot_SetTime))
            NewValue *= 50.0F / 1000.0F
            NewValue = CInt(NewValue)
            If NewValue < 0 Then NewValue = 0
            If NewValue > 50 Then NewValue = 50
            If NewValue <> OldSetTime Then
                OldSetTime = CInt(NewValue)
                tkbar_SetTime.Value = CInt(NewValue)
            End If
        End If
        ' ---------------------------------------------------------------------- Slot Gain
        If Slot_Gain >= 0 Then
            Static OldGain As Single = -1
            Dim NewValue As Single = CInt(Slots.ReadSlot_NoNan(Slot_Gain))
            NewValue *= 50.0F / 1000.0F
            NewValue = CInt(NewValue)
            If NewValue < 1 Then NewValue = 1
            If NewValue > 50 Then NewValue = 50
            If NewValue <> OldGain Then
                OldGain = NewValue
                Gain = CInt(NewValue)
                tkbar_Gain.Value = Gain
            End If
        End If
        ' ---------------------------------------------------------------------- Slot Speed
        If Slot_SetTime >= 0 Then
            Static OldSpeed As Int32 = -1
            Dim NewValue As Single = CInt(Slots.ReadSlot_NoNan(Slot_Speed))
            NewValue *= 100.0F / 1000.0F
            NewValue = CInt(NewValue)
            If NewValue < 1 Then NewValue = 1
            If NewValue > 100 Then NewValue = 100
            If NewValue <> OldSpeed Then
                OldSpeed = CInt(NewValue)
                tkbar_Speed.Value = CInt(NewValue)
            End If
        End If
    End Sub

    ' ================================================================================================
    '  GRAPH PAPER UPDATE - SLOW TIMER ( 10 Hz )
    ' ================================================================================================
    Private UpdateGraphPaper As Boolean
    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        If chk_RecordAudio.Checked Then
            AudioLevel = AudioRecPlay.GetLevel
            VuMeter1.Draw(pbox_VuMeter, AudioLevel, , True, -40)
        End If
        If PlayingAudio And Not MouseLeftButtonPressed() Then
            GraphPaper1.SetTimeMillisec(Audio1.GetPosition)
        End If
        If PlayingAudio Or RecordingSession Or UpdateGraphPaper Then
            UpdateGraphPaper = False
            GraphPaper1.Update(pbox_Paper)
            GraphPaper1.UpdateAudio(pbox_AudioLevel)
        End If
    End Sub

    ' ================================================================================================
    '  CONTROLS
    ' ================================================================================================
    Private Sub btn_RedMarker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RedMarker.Click
        SetNewMarker(4)
    End Sub
    Private Sub btn_OrangeMarker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OrangeMarker.Click
        SetNewMarker(3)
    End Sub
    Private Sub btn_GreenMarker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_GreenMarker.Click
        SetNewMarker(2)
    End Sub
    Private Sub btn_BlueMarker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_BlueMarker.Click
        SetNewMarker(1)
    End Sub
    Friend Sub SetNewMarker(ByVal ColorIndex As Byte)
        If ToolStripButton_EditNotes.Checked Then
            NewMarker = ColorIndex
        Else
            DataArray1.SetMarker(CInt(GraphPaper1.GetTimeMillisec / 100) - 1, ColorIndex)
        End If
        UnsavedData = True
        UpdateGraphPaper = True
    End Sub
    Private Sub btn_DeleteMarker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DeleteMarker.Click
        For i As Int32 = -3 To 2
            DataArray1.SetMarker(CInt(GraphPaper1.GetTimeMillisec / 100) + i, 0)
        Next
        UnsavedData = True
        UpdateGraphPaper = True
    End Sub
    Private Sub btn_DeleteAllMarkers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DeleteAllMarkers.Click
        If MessageBox.Show("You are about to delete all the markers. " + _
                            vbCrLf + vbCrLf + "Do you want to proceed?", _
                            "Warning from Emotion Meter", _
                            MessageBoxButtons.YesNo, _
                            MessageBoxIcon.Warning, _
                            MessageBoxDefaultButton.Button2, _
                            CType(&H40000, MessageBoxOptions)) = DialogResult.Yes Then
            DataArray1.DeleteAllMarkers()
            UnsavedData = True
            UpdateGraphPaper = True
        End If
    End Sub

    ' ================================================================================================
    '  START STOP SESSION
    ' ================================================================================================
    Private Sub btn_StartSession_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_StartSession.Click
        PlayAudioStop()
        RecordingSession = Not RecordingSession
        Session_StartStop()
    End Sub
    Friend Sub Session_StartStop()
        If RecordingSession Then
            If UnsavedData Then AskForSaveData()
            btn_StartSession.Text = "Stop"
            btn_StartSession.BackColor = Color.FromArgb(255, 230, 0)
            btn_StartSession.FlatAppearance.MouseOverBackColor = Color.FromArgb(245, 245, 0)
            DataArray1.Flush()
            DataArray1.Fill(999, -999, 0, 0)
            ResetDeltaTime()
            hipass1.ResetTo(-TaValue)
            StartRecord()
            SignalReaderStart()
            LastDataFile = "Data file not saved"
            StatusStrip_ShowFileName(LastDataFile)
            UnsavedData = True
        Else
            StopRecord()
            StopSession()
            UpdateGraphPaper = True
        End If
    End Sub

    Friend Sub StopSession()
        btn_StartSession.Text = "Start session"
        btn_StartSession.BackColor = Color.FromArgb(240, 230, 150)
        btn_StartSession.FlatAppearance.MouseOverBackColor = Color.LightYellow
        SignalReaderStop()
        RecordingSession = False
    End Sub

    ' ================================================================================================
    '  START STOP AUDIO
    ' ================================================================================================
    Private Sub btn_AudioInputs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_AudioInputs.Click
        Shell("control mmsys.cpl,,1", AppWinStyle.NormalFocus)
    End Sub

    Private Sub btn_PlayAudio_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_PlayAudio.Click
        PlayingAudio = Not PlayingAudio
        StartStopPlayAudio()
    End Sub
    Private Sub StartStopPlayAudio()
        If PlayingAudio Then
            Dim AudioFileName As String
            AudioFileName = IO.Path.ChangeExtension(LastDataFile, ".mp3")
            If Not IO.File.Exists(AudioFileName) Then
                AudioFileName = Application.StartupPath + "\DataFiles\Temp.mp3"
            End If
            If Not IO.File.Exists(AudioFileName) Then
                AudioFileName = IO.Path.ChangeExtension(LastDataFile, ".wav")
            End If
            If Not IO.File.Exists(AudioFileName) Then
                AudioFileName = Application.StartupPath + "\DataFiles\Temp.wav"
            End If
            If IO.File.Exists(AudioFileName) Then
                btn_PlayAudio.Text = "Stop"
                btn_PlayAudio.BackColor = Color.FromArgb(255, 230, 0)
                btn_PlayAudio.FlatAppearance.MouseOverBackColor = Color.FromArgb(245, 245, 0)
                StopSession()
                Audio1.OpenFile(AudioFileName)
                Audio1.Seek(GraphPaper1.GetTimeMillisec)
                Audio1.Play()
            Else
                PlayingAudio = False
            End If
        Else
            PlayAudioStop()
        End If
    End Sub
    Friend Sub PlayAudioStop()
        btn_PlayAudio.Text = "Play"
        btn_PlayAudio.BackColor = Color.FromArgb(240, 230, 150)
        btn_PlayAudio.FlatAppearance.MouseOverBackColor = Color.LightYellow
        PlayingAudio = False
        Audio1.Stop()
    End Sub

    Private Sub TrackAudioPosition_RepetitionLimited()
        If PlayingAudio Then
            Audio1.SeekAndPlay_RepetitionLimited(GraphPaper1.GetTimeMillisec)
        End If
    End Sub

    Private Sub TrackAudioPosition_Immediate()
        If PlayingAudio Then
            Audio1.Seek(GraphPaper1.GetTimeMillisec)
            Audio1.Play()
        End If
    End Sub

    ' ===================================================================================================
    '  SELECT AUDIO INPUT 
    ' ===================================================================================================
    Private Audio1 As AudioRecPlay = New AudioRecPlay
    Friend SelectedAudioIn As Int32 = 0

    Private Sub chk_RecordAudio_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_RecordAudio.CheckedChanged
        EnableAudioControls()
    End Sub
    Private Sub EnableAudioControls()
        If chk_RecordAudio.Checked Then
            btn_AudioInputs.Enabled = True
            btn_AudioInputs.BackColor = Color.White
            cmb_AudioInDevices.Enabled = True
            GroupBox_Compression.Enabled = True
            Me.Height = 533
        Else
            btn_AudioInputs.Enabled = False
            btn_AudioInputs.BackColor = Color.LightGray
            cmb_AudioInDevices.Enabled = False
            GroupBox_Compression.Enabled = False
            VuMeter1.Draw(pbox_VuMeter, 0)
            Me.Height = 490
        End If
    End Sub

    Private Sub cmb_AudioInDevices_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioInDevices.DropDown
        cmb_AudioInDevices.ItemHeight = 16
        FillAudioDevicesCombo()
    End Sub
    Private Sub cmb_AudioInDevices_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioInDevices.DropDownClosed
        cmb_AudioInDevices.ItemHeight = 11
    End Sub
    Private Sub cmb_AudioInDevices_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_AudioInDevices.SelectedIndexChanged
        SelectedAudioIn = cmb_AudioInDevices.SelectedIndex
        AudioRecPlay.StartLevelMeter(SelectedAudioIn)
    End Sub
    Private Sub FillAudioDevicesCombo()
        Dim sa As String() = AudioRecPlay.GetDevNames
        If sa.Length = 0 Then ReDim sa(0) : sa(0) = ""
        cmb_AudioInDevices.Items.Clear()
        For i As Int32 = 0 To sa.Length - 1
            cmb_AudioInDevices.Items.Add(ExtractDeviceName(sa(i)))
        Next
        Combo_SetIndex(cmb_AudioInDevices, SelectedAudioIn)
    End Sub
    Private Sub Combo_SetIndex(ByVal combo As ComboBox, ByRef index As Int32)
        Dim n As Int32 = combo.Items.Count
        If n = 0 Then Return
        If index < 0 Then index = 0
        If index > n - 1 Then index = n - 1
        combo.SelectedIndex = index
    End Sub
    Private Function ExtractDeviceName(ByVal s As String) As String
        If s = Nothing Then Return ""
        Dim i As Int32 = InStr(s, "(") - 1
        Dim s2 As String = ""
        If i > 1 Then s2 = s.Remove(i)
        s2 = s2.Trim
        If s.ToLower.Contains("usb") Then s2 = s2 + " USB"
        Return s2
    End Function

    ' ================================================================================================
    '  AUDIO RECORD FILES
    ' ================================================================================================
    Private Sub StartRecord()
        If Not chk_RecordAudio.Checked Then Return
        Audio1.Record(True, _
                      True, _
                      44100, _
                      SelectedAudioIn)
    End Sub
    Private Sub StopRecord()
        If Not chk_RecordAudio.Checked Then Return
        Dim TempName As String = Application.StartupPath + "\DataFiles\temp.wav"
        Audio1.Save(TempName)
    End Sub
    Friend Sub ChangeTempFilesToFinalName(ByVal FinalName As String)
        Audio1.Close()
        If IO.File.Exists(Application.StartupPath + "\DataFiles\temp.wav") Then
            ' --------------------------------------------------------- change Temp-Names to Final-Names 
            ' txt is already saved from the "SaveDataTo" function
            ChangeTempFileToFinalName(".wav", FinalName)
            ChangeTempFileToFinalName(".rtf", FinalName)
        Else
            ' --------------------------------------------------------- copy WAV, MP3 and RTF files with Final-Name
            ' txt is already saved from the "SaveDataTo" function
            CopyFileToFinalName(".wav", FinalName)
            CopyFileToFinalName(".mp3", FinalName)
            CopyFileToFinalName(".rtf", FinalName)
        End If
    End Sub
    Private Sub ChangeTempFileToFinalName(ByVal extension As String, ByVal finalname As String)
        Dim TempName As String = Application.StartupPath + "\DataFiles\temp" + extension
        If IO.File.Exists(TempName) Then
            finalname = IO.Path.ChangeExtension(finalname, extension)
            finalname = IO.Path.GetFileName(finalname)
            My.Computer.FileSystem.RenameFile(TempName, finalname)
        End If
    End Sub
    Private Sub CopyFileToFinalName(ByVal extension As String, ByVal finalname As String)
        Dim TempName As String = LastDataFile
        TempName = IO.Path.ChangeExtension(TempName, extension)
        If IO.File.Exists(TempName) Then
            finalname = IO.Path.ChangeExtension(finalname, extension)
            If TempName <> finalname Then
                My.Computer.FileSystem.CopyFile(TempName, finalname, True)
            End If
        End If
    End Sub

    Friend Sub DeleteTempFiles()
        On Error Resume Next
        Dim tempWavName As String = Application.StartupPath + "\DataFiles\temp.wav"
        Dim tempMp3Name As String = Application.StartupPath + "\DataFiles\temp.mp3"
        Dim tempRtfName As String = Application.StartupPath + "\DataFiles\temp.rtf"
        IO.File.Delete(tempWavName)
        IO.File.Delete(tempMp3Name)
        IO.File.Delete(tempRtfName)
    End Sub

    ' ================================================================================================
    '  CONVERT TO MP3
    ' ================================================================================================
    Private Sub btn_ConvertAllToMp3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ConvertAllToMp3.Click
        StopSession()
        PlayAudioStop()
        Audio1.Close()
        Dim FileNames As Collections.ObjectModel.ReadOnlyCollection(Of String)
        Dim wildcards() As String = {"*.wav"}
        FileNames = My.Computer.FileSystem.GetFiles(Application.StartupPath + "\DataFiles\", _
                                                    FileIO.SearchOption.SearchAllSubDirectories, _
                                                    wildcards)
        For Each fname As String In FileNames
            ConvertToMp3(fname)
        Next
    End Sub

    Private Sub ConvertToMp3(ByVal WavFileName As String)
        Audio1.WavToMp3(WavFileName, _
                        CInt(Val(cmb_BitsPerSec.Text)), _
                        True, _
                        7, _
                        , _
                        , _
                        AddressOf ProgressCallback)
        IO.File.Delete(WavFileName)
        VuMeter2.Draw(pbox_AudioLevel, 0)
        GraphPaper1.UpdateAudio(pbox_AudioLevel)
    End Sub

    Dim VuMeter2 As VuMeter = New VuMeter
    Private Sub ProgressCallback(ByVal progress As Single)
        VuMeter2.Draw(pbox_AudioLevel, progress, , , , 1, True, "  Converting to MP3", 0.25, 0.7)
    End Sub

End Class