﻿Module Module_Program

    Friend MinTaScale As Single = 6.5
    Friend MaxTaScale As Single = 0

    Friend MinSignalScale As Single = -45
    Friend MaxSignalScale As Single = 75

    Friend DeltaTime As Single

    Friend OutputValue As Single
    Friend TaValue As Single

    Friend RecordingSession As Boolean
    Friend PlayingAudio As Boolean

    Friend UnsavedData As Boolean
    Friend LastDataFile As String

    Friend NewMarker As Byte = 0

    Friend AudioLevel As Single

    Friend VuMeter1 As VuMeter = New VuMeter

    ' ----------------------------------------------------------------------------------------------------------
    ' DataArrayLen length : 6 hours === 6 * 3600 * 10 Hz === 216000 samples === 2 mega bytes
    ' ----------------------------------------------------------------------------------------------------------
    Friend Const DataArrayLen As Int32 = 6 * 3600 * 10

    Friend DataArray1 As DataArray = New DataArray(DataArrayLen)

    Friend GraphPaper1 As GraphPaper = New GraphPaper

    Friend Sub LimitDeltaTime()
        Dim MaxDelta As Single = DataArray1.GetNumEntries * 100
        If DeltaTime > MaxDelta Then DeltaTime = MaxDelta
        If DeltaTime < 0 Then DeltaTime = 0
    End Sub

    Friend Sub ResetDeltaTime()
        DeltaTime = 0
    End Sub


    ' ====================================================================================================
    '  MilliTimer
    ' ====================================================================================================
    Private WithEvents mTimer As AccurateTimer = New AccurateTimer

    Friend Sub SignalReaderStart()
        mTimer.Interval = 100
        mTimer.Start()
    End Sub

    Friend Sub SignalReaderStop()
        mTimer.Stop()
    End Sub

    Private Sub mTimer_TimerTick(ByVal TotalMillisec As Double) Handles mTimer.Tick
        ' -------------------------------------------------------------------------- convert to decibel
        Dim db As Double = VoltToDecibel(AudioLevel)
        db = 1 + db / 30
        If db < 0 Then db = 0
        If db > 1 Then db = 1
        ' -------------------------------------------------------------------------- add to array
        DataArray1.AddElement(TaValue, OutputValue, NewMarker, CByte(db * 255))
        NewMarker = 0
    End Sub

    Private Function VoltToDecibel(ByVal v As Double) As Double
        VoltToDecibel = 20 * Math.Log(v, 10)
    End Function

End Module
