﻿Module Module_StatusStripControls

    Friend RecordDate As DateTime = Date.Now

    Private WithEvents ssTimer As New Windows.Forms.Timer
    Private WithEvents ssLabel1 As New ToolStripStatusLabel
    Private WithEvents ssLabel2 As New ToolStripStatusLabel

    Private StatusStrip1 As StatusStrip

    Friend Sub SetStatusStripControls(ByRef StStrip As StatusStrip)
        StatusStrip1 = StStrip
        With ssLabel1
            .AutoSize = False
            .Size = New Size(200, .Size.Height)
            .Font = New Font("Arial", 8, FontStyle.Regular)
            .TextAlign = ContentAlignment.MiddleCenter
            .BackColor = StatusStrip1.BackColor
            .ForeColor = Color.Black
            .Text = "--------------"
        End With
        With ssLabel2
            .Spring = True
            .AutoSize = False
            .Font = New Font("Arial", 8, FontStyle.Regular)
            .TextAlign = ContentAlignment.MiddleCenter
            .BackColor = StatusStrip1.BackColor
            .ForeColor = Color.Black
            .Text = "--------------"
        End With
        StatusStrip1.Items.Clear()
        StatusStrip1.Items.Add(ssLabel1)
        StatusStrip1.Items.Add(ssLabel2)
        ssTimer.Interval = 1000
        ssTimer.Start()
    End Sub

    Private Sub ssTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ssTimer.Tick
        UpdateStatusTime()
    End Sub

    Friend Sub UpdateStatusTime()
        If RecordingSession Then RecordDate = Date.Now
        Dim d As DateTime = RecordDate.AddMilliseconds(-DeltaTime)
        If RecordingSession Then
            ssLabel2.BackColor = Color.FromArgb(220, 255, 180)
            ssLabel2.Text = "Real time " + d.ToLongDateString + " " + d.ToLongTimeString
        Else
            ssLabel2.BackColor = StatusStrip1.BackColor
            ssLabel2.Text = "Recorded " + d.ToLongDateString + " " + d.ToLongTimeString
        End If
    End Sub

    Friend Sub StatusStrip_ShowFileName(ByVal name As String)
        ssLabel1.Text = IO.Path.GetFileNameWithoutExtension(name)
    End Sub

    Friend Sub StatusStrip_SetRecordDate(ByVal dateString As String)
        RecordDate = DateTime.Parse(dateString, GCI)
    End Sub
    Friend Function StatusStrip_GetRecordDate() As String
        Return RecordDate.ToString(GCI)
    End Function

End Module
