﻿Module Module_Utils


    ' =============================================================================
    '   StartThereminoHAL - ASYNC START
    ' =============================================================================
    Public Sub StartThereminoHAL_Async()
        ' --------------------------------------------------------- asynchronously start the Thread 
        Dim objThread As Threading.Thread
        objThread = New Threading.Thread(New Threading.ParameterizedThreadStart(AddressOf StartThereminoHAL))
        ' --------------------------------------------------------- make the thread as background thread.
        objThread.IsBackground = True
        ' --------------------------------------------------------- set the Priority of the thread.
        objThread.Priority = Threading.ThreadPriority.BelowNormal
        ' --------------------------------------------------------- start the thread.
        objThread.Start()
    End Sub
    Friend Sub StartThereminoHAL(ByVal obj As Object)
        StartThereminoHAL()
    End Sub

    ' =============================================================================
    '   THEREMINO HAL - START STOP
    ' =============================================================================
    Private HalProcess As Process = Nothing
    Friend Sub StartThereminoHAL()
        If HalProcess Is Nothing OrElse HalProcess.HasExited Then
            Dim path As String = Application.StartupPath & "\Theremino_HAL.exe"
            If Not My.Computer.FileSystem.FileExists(path) Then
                path = Application.StartupPath & "\Theremino_HAL\Theremino_HAL.exe"
            End If
            If Not My.Computer.FileSystem.FileExists(path) Then Return
            Dim psi As New ProcessStartInfo
            psi.WorkingDirectory = IO.Path.GetDirectoryName(path)
            psi.FileName = path
            HalProcess = Process.Start(psi)
            HalProcess.SynchronizingObject = Form1
            ' ----------------------------------------------- Wait HAL really started 
            For i As Int32 = 1 To 100
                Threading.Thread.Sleep(100)
                HalProcess.Refresh()
                If HalProcess.MainWindowTitle.Contains(".") Then Exit For
            Next
        End If
    End Sub
    Friend Sub StopThereminoHAL()
        If HalProcess IsNot Nothing Then
            If HalProcess.HasExited Then
                HalProcess = Nothing
                Return
            End If
            For i As Int32 = 1 To 100
                HalProcess.CloseMainWindow()
                HalProcess.Refresh()
                Threading.Thread.Sleep(100)
                If HalProcess.HasExited Then
                    HalProcess = Nothing
                    Return
                End If
            Next
            HalProcess.Kill()
            HalProcess = Nothing
        End If
    End Sub

    ' =============================================================================
    '   Close App By Filename
    ' =============================================================================
    Friend Sub CloseAppByFilename(ByVal FileName As String)
        Dim p() As System.Diagnostics.Process
        p = System.Diagnostics.Process.GetProcesses()
        For i As Int32 = 0 To p.Length - 1
            Try
                If p(i).Id = System.Diagnostics.Process.GetCurrentProcess.Id Then Continue For

                If Not p(i).ProcessName = FileName Then Continue For
                '
                'Debug.Print(p(i).ProcessName)
                '
                p(i).CloseMainWindow()
                p(i).Close()
            Catch
            End Try
        Next
        '
        p = System.Diagnostics.Process.GetProcesses()
        For i As Int32 = 0 To p.Length - 1
            Try
                If p(i).Id = System.Diagnostics.Process.GetCurrentProcess.Id Then Continue For
                If Not p(i).ProcessName = FileName Then Continue For
                '
                'Debug.Print(p(i).ProcessName)
                '
                If Not p(i).WaitForExit(1000) Then
                    Try
                        p(i).Kill()
                    Catch ex As Exception
                    End Try
                End If
            Catch
            End Try
        Next
    End Sub


    '' =========================================================================
    ''  THEREMINO HAL - START STOP -
    '' =========================================================================
    'Private HalProcess As Process = Nothing
    'Private Sub StartThereminoHAL()
    '    Dim path As String = Application.StartupPath & "\Theremino_HAL.exe"
    '    If Not My.Computer.FileSystem.FileExists(path) Then
    '        path = Application.StartupPath & "\Theremino_HAL\Theremino_HAL.exe"
    '    End If
    '    If Not My.Computer.FileSystem.FileExists(path) Then Return
    '    Dim psi As New ProcessStartInfo
    '    psi.WorkingDirectory = IO.Path.GetDirectoryName(path)
    '    psi.FileName = path
    '    HalProcess = Process.Start(psi)
    'End Sub
    'Private Sub StopThereminoHAL()
    '    If HalProcess IsNot Nothing AndAlso Not HalProcess.HasExited Then
    '        Try
    '            HalProcess.CloseMainWindow()
    '        Finally
    '        End Try
    '    End If
    'End Sub


    ' =======================================================================================================
    '   PLAY CLICK SOUND
    ' =======================================================================================================
    Private sw As Stopwatch = New Stopwatch
    Friend Sub PlayClickSound()
        If sw.IsRunning AndAlso sw.ElapsedMilliseconds < 200 Then Return
        My.Computer.Audio.Play(My.Resources.Click3c, AudioPlayMode.Background)
        sw.Reset()
        sw.Start()
    End Sub


    ' =======================================================================================================
    '   SMOOTHING
    ' =======================================================================================================
    Friend Sub SmoothValue(ByRef value As Single, ByVal new_value As Single, ByVal speed As Single)
        If speed > 1 Then speed = 1
        value += (new_value - value) * speed
    End Sub

    Friend Sub SmoothValue_Pow(ByRef value As Single, ByVal new_value As Single, ByVal speed As Single)
        Dim delta As Single = new_value - value
        Dim delta_sgn As Single = Math.Sign(delta)
        Dim delta_abs As Single = Math.Abs(delta)
        Dim delta_pow As Single

        delta_pow = CSng((0.003 * speed * delta_abs) ^ 2)

        If delta_pow >= delta_abs Then
            value = new_value
        Else
            value += delta_sgn * delta_pow
        End If
    End Sub

    ' =======================================================================================================
    '   MISH UTILS
    ' =======================================================================================================
    Friend Sub InitPictureboxImage(ByVal pbox As PictureBox)
        With pbox
            If .ClientSize.Width < 1 Or .ClientSize.Height < 1 Then Return
            If .Image Is Nothing OrElse .Image.Width <> .ClientSize.Width _
                                 OrElse .Image.Height <> .ClientSize.Height Then
                .Image = New Bitmap(.ClientRectangle.Width, _
                                    .ClientRectangle.Height, _
                                    Imaging.PixelFormat.Format24bppRgb)
            End If
        End With
    End Sub

    Friend Function RemoveExtension(ByVal str As String) As String
        On Error Resume Next
        Return PlatformAdjustedFileName(IO.Path.GetDirectoryName(str) & "\" & IO.Path.GetFileNameWithoutExtension(str))
    End Function

    Friend Function RoundTo05(ByVal n As Single) As Single
        Return CInt(n * 2.0F) / 2.0F
    End Function

    Friend Function TimeSpanToString(ByVal ts As TimeSpan) As String
        Return ts.ToString.Substring(0, 8)
    End Function

    Friend Function MillisecToString(ByVal millisec As Single) As String
        If millisec >= 60000 Then
            'return (millisec / 60000).ToString("0.000", GCI) + " min"
            Dim ts As TimeSpan = TimeSpan.FromMilliseconds(millisec)
            Return Math.Floor(ts.TotalMinutes).ToString() + "m " _
                                + ts.Seconds.ToString + "." + _
                                (ts.Milliseconds \ 100).ToString + "s"
        ElseIf millisec >= 1000 Then
            Return (millisec / 1000).ToString("0.0", GCI) + " Sec"
        Else
            Return millisec.ToString("0", GCI) + " mS"
        End If
    End Function

    Friend Function MillisecToMinAndSec(ByVal millisec As Single) As String
        If millisec >= 60000 Then
            Dim ts As TimeSpan = TimeSpan.FromMilliseconds(millisec)
            Return Math.Floor(ts.TotalMinutes).ToString() + "m " _
                                    + ts.Seconds.ToString + "s"
        Else
            Return (millisec / 1000).ToString("0", GCI) + " s"
        End If
    End Function

    Friend Function MillisecToHMS(ByVal millisec As Single) As String
        Dim ts As TimeSpan = TimeSpan.FromMilliseconds(millisec)
        Return ts.ToString.Substring(0, 8)
    End Function

    Friend Function MillisecToHourMinAndSec(ByVal millisec As Single) As String
        If millisec >= 3600000 Then
            Dim ts As TimeSpan = TimeSpan.FromMilliseconds(millisec)
            Return Math.Floor(ts.TotalHours).ToString() + "h " + _
                   Math.Floor(ts.Minutes).ToString() + "m " + _
                              ts.Seconds.ToString + "s"
        ElseIf millisec >= 60000 Then
            Dim ts As TimeSpan = TimeSpan.FromMilliseconds(millisec)
            Return Math.Floor(ts.TotalMinutes).ToString() + "m " _
                                    + ts.Seconds.ToString + "s"
        Else
            Return (millisec / 1000).ToString("0", GCI) + " Sec"
        End If
    End Function

    Friend Function MouseLeftButtonPressed() As Boolean
        Return (Control.MouseButtons And Windows.Forms.MouseButtons.Left) <> Windows.Forms.MouseButtons.None
    End Function
    Friend Function MouseRightButtonPressed() As Boolean
        Return (Control.MouseButtons And Windows.Forms.MouseButtons.Right) <> Windows.Forms.MouseButtons.None
    End Function
    Friend Function MouseMidButtonPressed() As Boolean
        Return (Control.MouseButtons And Windows.Forms.MouseButtons.Middle) <> Windows.Forms.MouseButtons.None
    End Function

End Module
